---
title: Make Windows Suck Less
author: geoff-doty
date: 2015-05-14
template: article.jade
---

You ever feel like there is a great divide among developers, like the parting of the ocean where on one side you have Windows developers and on the other -- the rest of the entire development world!

I did.

So, I bought a Mac!

Then, I figured out how to make **Windows Suck Less&trade;** for development. On this short trip over Windows short comings I'm going to provide the perfect recipe to fix one aspect of Windows to achieve my over-arching desire to make **Windows Suck Less&trade;**

---
##### Fun FACT: The latest Visual Studio 2015 install ships with Google's Chrome Browser, Git, and NodeJS.
>   What ever happened to Internet Explorer, Visual Source Safe, and ASP.NET?

---

### FIX - The Command Prompt

For the love that all developer hold holy -- kill the Windows command prompt. This 80's throw-back `CMD` keeps making it into the operating system after operating system.  Why?!  Ok, I know why, but still: *"Developers, Developers, Developers!"* want a better terminal.

What is a better terminal?  It is one that provides

- Tab completion
- History
- Syntax highlighting
- Multiple tabbed sessions
- And access to tools used on other platforms such as `ssh`, `curl`, `ls` ect...

So how do we achieve this?

With two pieces of software: [GIT](http://git-scm.com/) of and  [ConEmu](http://conemu.github.io/)

#### Git

Git, while best known as the little version control system that could, it can do so much more.  It is not the most adopted version control system out there for no reason -- oh the sure POWER! What other version control system lets you build your own version control system using itself?  This and other reasons why git is a key ingredient into making Windows Suck Less&trade; just by install it.

*No self respecting developer would use anything else;)*

Where git really shines on Windows is with the inclusion of over 80 command line tools that leverage the playing field between Windows, Mac and Linux.  Command line tools like `sh`, `ssh`, `ls`, `mkdir`, `openssl`, `curl`, and 80 more...

> Git is not *just* version control, it is a micro development eco-system and the *secret sauce* to make **Windows Suck Less&trade;**

But **git** alone does not complete our _domination_ of the Windows command prompt.  We want to add one more nail to the coffin to insure this 80's throw-back-life-sucker stays down.

> Here comes the **STAKE!**

#### ConEmu

ConEmu starts a console program in a hidden console window, in our case the Git Bash , and then provides an alternative customizable GUI window with various features

- Multiple tabbed window interface
- Ability to hide and show from a keyboard shortcut
- XTerm 256 colors 
- Better fonts including support for bold, italic and underline
- Transparency
- Copy and Paste

Just to mention a few.

So what are you waiting for, go forth and install these bad boys and make **Windows Suck Less&trade;**

<small>DISCLAIMER: The solutions provided here were tested on Windows 7/8.  Use at your own risk.</small>